package train;

import java.util.ArrayList;

import train.car.Car;
import train.locomotive.Locomotive;

/**
 * Die Klasse ist fr die Zusammenstellung eines Zuges verantwortlich.
 * 
 * @author Tobias Hennchen 
 * @version 2007.06.14
 */
public class Train {
    
    //Lok des Zugs
    private Locomotive loc;

    //Liste der Wagons
    private ArrayList cars;
    
    /**
     * Konstruktor
     * @param Der Zug erwartet eine Locomotive um den Zug erstellen zu knnen.
     */
    public Train(Locomotive loc) {
        this.loc = loc;

        //Erzeugen der Liste fr die Wagons
        cars = new ArrayList();
    }

    /**
     * Fgt Wagon ans Ende der Liste an.
     * @param Der Zug erwartet einen Wagen um ihn an den Zug dranzuhngen
     */   
    public void add(Car car) {
        cars.add(car);
    }

     /**
     * Gibt gesamte Personkapazitt zurck
     * @return Gibt gesamte Personkapazitt zurck
     */      
    public int getCapacity() {

        int cap = 0;

        //Gehe durch die vorgegebenen Elemente
        //und addiere die Kapazitten
        for (int i = 0; i < cars.size(); i++) {
            if (cars.get(i) != null) {
                //Typcast machen
                cap = cap + ((Car) cars.get(i)).getCapacity();
            }
        }

        return cap;
    }

     /**
     * Gibt gesamte Zuglnge zurck
     * @return Gibt gesamte Zuglnge zurck
     */  
    public int getLength() {
        //Initialisierung mit Lnge der Lok
        int len = loc.getLength();

        //Gehe durch die vorgegebenen Elemente
        //und addiere die Lngen
        for (int i = 0; i < cars.size(); i++) {
            if (cars.get(i) != null) {
                len += ((Car) cars.get(i)).getLength();
            }
        }

        return len;
    }

     /**
     * Entfernt den letzten Wagen
     * @return Gibt den letzen Wagen zurck
     */     
    public Car removeLast() {
        if (cars.size() > 0) {
            return (Car) cars.remove(cars.size()-1);
        } else {
            return null;
        }
    }


     /**
     * Text zusammenstellen
     * @return String mit dem Zugauufbau
     */ 
    public String toString() {

        StringBuffer s = new StringBuffer();

        s.append(loc.toString());

        for (int i=0; i < cars.size(); i++) {
            s.append(" <-> ");
            s.append(cars.get(i).toString());
        }

        return s.toString();
    }

}
